##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
use Tk;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::TextUndo;
use Tk::Photo;

    my $dir=&GetCWD;

    my ($title,$label_1,$value_1,$label_2,$value_2,$label_3,$value_3,$label_4,$value_4,$label_5,$value_5) = ("Query-Dir(LIBXSLT)","Input-XML-File : ",$dir, "Input-XSL-File : ",$dir, "Output-HTML-File : ",$dir);

    my $mw =  MainWindow->new(-title=>$title);
    $mw->geometry("400x300+100+100");
    my $imgLogo=$mw->Photo(-file=>"logo-mkc.gif");
    my $lblLogo=$mw->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $mw->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameH1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG4 = $frameH1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD4 = $frameH1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mw->Frame()->pack();
    my $frame3 = $mw->Frame()->pack();

#---1er champ
    my $libelE = $frameG2->Label(-text=>$label_1)->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    my $fieldE = $frameD2->Entry(-textvariable => \$value_1, -highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$fieldE => 'xview']);
#---2eme champ
    my $libelF = $frameG3->Label(-text=>$label_2)->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    my $fieldF = $frameD3->Entry(-textvariable => \$value_2, -highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$fieldF => 'xview']);
#---3eme champ
    my $libelG = $frameG4->Label(-text=>$label_3)->pack(-padx=>5);
    my $defil3 = $frameD4-> Scrollbar(-orient => "horizontal");
    my $fieldG = $frameD4->Entry(-textvariable => \$value_3, -highlightcolor => "red", -xscrollcommand => ['set' => $defil3] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil3->pack(-fill => 'x',
		  -expand => 1);
    $defil3->configure(-command => [$fieldG => 'xview']);
#----

    my $raz = $mw->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&eraseField)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $mw->Button(-text=>'Go', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadQUERYMODELE)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $mw->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpQUERYMODELE)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $mw->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$mw->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
MainLoop;

#----------------------------------------------------------------
sub GetCWD {
  use Cwd;
  my $dir;
  $dir = getcwd;
  # method from Cwd.pm
  $dir =~ s/\n//g;
  if ($dir !~ m#/$#) {
    $dir = "$dir/";
  }
  return $dir;
} 
#----------------------------------------------------------------
sub eraseField {
    if (Exists($fieldF)) {$fieldF->delete(0, 'end')};
    if (Exists($fieldE)) {$fieldE->delete(0, 'end')};
    if (Exists($fieldG)) {$fieldG->delete(0, 'end')};
}
#----------------------------------------------------------------
sub helpQUERYMODELE {
    if (! Exists ($pn1)) {
	$pn1 = $mw->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				 -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("TextUndo")->pack(-side => 'bottom',
						      -fill => 'both',
						      -expand => 1);
	
	$texte2->Text(-setgrid => 'true');
	
	my $tmpfile="help_processeurXSLT.txt";
	if (!open(OUTFILE, "$tmpfile")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $tmpfile \n");
	}
	else {
	    close(OUTFILE);
	    $texte2->IncludeFile($tmpfile);
	}
	
	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);
	
	my $w_save=$pn1->Button(-text => "Save",
				-command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}
#----------------------------------------------------------------
sub loadQUERYMODELE {
    my $chemin1=$fieldE->get();
    my $chemin2=$fieldF->get();
    my $chemin3=$fieldG->get();
    
    use XML::LibXML;
    use XML::LibXSLT;
    if (!open(OUTFILE, "$chemin1")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin1 \n");
	return;
    }
    
    close(OUTFILE);
    if (!open(OUTFILE, "$chemin2")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin2 \n");
	return;
    }
    close(OUTFILE);
    my $parserObj = XML::LibXML->new();
    my $xsltObj = XML::LibXSLT->new();
    my $inputXMLObj = $parserObj->parse_file($chemin1);
    my $inputStyleSheetObj = $parserObj->parse_file($chemin2);
    my $xsltObj = $xsltObj->parse_stylesheet($inputStyleSheetObj);
    my $resultsObj = $xsltObj->transform($inputXMLObj);
    my $htmlfile = $xsltObj->output_string($resultsObj);
    if (!open(OUTFILE, ">$chemin3")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin3 \n");
	return;
    }
    print OUTFILE $htmlfile;
    close(OUTFILE);
    my $tmpfile= "$chemin3";
    my $msg="$chemin3";
    &IncludedFileInWindow($tmpfile,$msg);
    
    use Win32::OLE;
    my $file = "$chemin3";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	&mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  
}

#---------------------------------------------------------
sub  mkPrintErreur {
	my $msg = shift;
	$mw->Dialog(
		 -title => "ERROR !",
		      -text  => $msg
		 )->Show();
}

#---------------------------------------------------------
sub  mkPrintMsgInfo {
    my $msg = shift;
    $mw->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub IncludedFileInWindow {
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $mw->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}
#----------------------------------------------------------------
